package cms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteHostAvailability invokes the cms.DeleteHostAvailability API synchronously
func (client *Client) DeleteHostAvailability(request *DeleteHostAvailabilityRequest) (response *DeleteHostAvailabilityResponse, err error) {
	response = CreateDeleteHostAvailabilityResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteHostAvailabilityWithChan invokes the cms.DeleteHostAvailability API asynchronously
func (client *Client) DeleteHostAvailabilityWithChan(request *DeleteHostAvailabilityRequest) (<-chan *DeleteHostAvailabilityResponse, <-chan error) {
	responseChan := make(chan *DeleteHostAvailabilityResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteHostAvailability(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteHostAvailabilityWithCallback invokes the cms.DeleteHostAvailability API asynchronously
func (client *Client) DeleteHostAvailabilityWithCallback(request *DeleteHostAvailabilityRequest, callback func(response *DeleteHostAvailabilityResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteHostAvailabilityResponse
		var err error
		defer close(result)
		response, err = client.DeleteHostAvailability(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteHostAvailabilityRequest is the request struct for api DeleteHostAvailability
type DeleteHostAvailabilityRequest struct {
	*requests.RpcRequest
	Id *[]string `position:"Query" name:"Id"  type:"Repeated"`
}

// DeleteHostAvailabilityResponse is the response struct for api DeleteHostAvailability
type DeleteHostAvailabilityResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateDeleteHostAvailabilityRequest creates a request to invoke DeleteHostAvailability API
func CreateDeleteHostAvailabilityRequest() (request *DeleteHostAvailabilityRequest) {
	request = &DeleteHostAvailabilityRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cms", "2019-01-01", "DeleteHostAvailability", "cms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteHostAvailabilityResponse creates a response to parse from DeleteHostAvailability response
func CreateDeleteHostAvailabilityResponse() (response *DeleteHostAvailabilityResponse) {
	response = &DeleteHostAvailabilityResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
