package cms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PutGroupMetricRule invokes the cms.PutGroupMetricRule API synchronously
func (client *Client) PutGroupMetricRule(request *PutGroupMetricRuleRequest) (response *PutGroupMetricRuleResponse, err error) {
	response = CreatePutGroupMetricRuleResponse()
	err = client.DoAction(request, response)
	return
}

// PutGroupMetricRuleWithChan invokes the cms.PutGroupMetricRule API asynchronously
func (client *Client) PutGroupMetricRuleWithChan(request *PutGroupMetricRuleRequest) (<-chan *PutGroupMetricRuleResponse, <-chan error) {
	responseChan := make(chan *PutGroupMetricRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PutGroupMetricRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PutGroupMetricRuleWithCallback invokes the cms.PutGroupMetricRule API asynchronously
func (client *Client) PutGroupMetricRuleWithCallback(request *PutGroupMetricRuleRequest, callback func(response *PutGroupMetricRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PutGroupMetricRuleResponse
		var err error
		defer close(result)
		response, err = client.PutGroupMetricRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PutGroupMetricRuleRequest is the request struct for api PutGroupMetricRule
type PutGroupMetricRuleRequest struct {
	*requests.RpcRequest
	EscalationsInfoN                      requests.Integer                      `position:"Query" name:"Escalations.Info.N"`
	Webhook                               string                                `position:"Query" name:"Webhook"`
	EscalationsWarnComparisonOperator     string                                `position:"Query" name:"Escalations.Warn.ComparisonOperator"`
	DynamicAlertSensitivity               string                                `position:"Query" name:"DynamicAlertSensitivity"`
	RuleName                              string                                `position:"Query" name:"RuleName"`
	EffectiveInterval                     string                                `position:"Query" name:"EffectiveInterval"`
	NoDataPolicy                          string                                `position:"Query" name:"NoDataPolicy"`
	NoEffectiveInterval                   string                                `position:"Query" name:"NoEffectiveInterval"`
	EmailSubject                          string                                `position:"Query" name:"EmailSubject"`
	EscalationsCriticalN                  requests.Integer                      `position:"Query" name:"Escalations.Critical.N"`
	EscalationsInfoPreCondition           string                                `position:"Query" name:"Escalations.Info.PreCondition"`
	MetricName                            string                                `position:"Query" name:"MetricName"`
	EscalationsWarnTimes                  requests.Integer                      `position:"Query" name:"Escalations.Warn.Times"`
	Period                                string                                `position:"Query" name:"Period"`
	EscalationsWarnThreshold              string                                `position:"Query" name:"Escalations.Warn.Threshold"`
	ContactGroups                         string                                `position:"Query" name:"ContactGroups"`
	EscalationsCriticalStatistics         string                                `position:"Query" name:"Escalations.Critical.Statistics"`
	RuleType                              string                                `position:"Query" name:"RuleType"`
	GroupId                               string                                `position:"Query" name:"GroupId"`
	ExtraDimensionJson                    string                                `position:"Query" name:"ExtraDimensionJson"`
	Labels                                *[]PutGroupMetricRuleLabels           `position:"Query" name:"Labels"  type:"Repeated"`
	EscalationsWarnN                      requests.Integer                      `position:"Query" name:"Escalations.Warn.N"`
	Interval                              string                                `position:"Query" name:"Interval"`
	RuleId                                string                                `position:"Query" name:"RuleId"`
	EscalationsCriticalThreshold          string                                `position:"Query" name:"Escalations.Critical.Threshold"`
	EscalationsInfoStatistics             string                                `position:"Query" name:"Escalations.Info.Statistics"`
	DynamicAlertHistoryDataRange          string                                `position:"Query" name:"DynamicAlertHistoryDataRange"`
	EscalationsWarnPreCondition           string                                `position:"Query" name:"Escalations.Warn.PreCondition"`
	EscalationsInfoComparisonOperator     string                                `position:"Query" name:"Escalations.Info.ComparisonOperator"`
	SilenceTime                           requests.Integer                      `position:"Query" name:"SilenceTime"`
	CompositeExpression                   PutGroupMetricRuleCompositeExpression `position:"Query" name:"CompositeExpression"  type:"Struct"`
	EscalationsInfoTimes                  requests.Integer                      `position:"Query" name:"Escalations.Info.Times"`
	EscalationsCriticalTimes              requests.Integer                      `position:"Query" name:"Escalations.Critical.Times"`
	EscalationsWarnStatistics             string                                `position:"Query" name:"Escalations.Warn.Statistics"`
	EscalationsInfoThreshold              string                                `position:"Query" name:"Escalations.Info.Threshold"`
	Namespace                             string                                `position:"Query" name:"Namespace"`
	Category                              string                                `position:"Query" name:"Category"`
	EscalationsCriticalComparisonOperator string                                `position:"Query" name:"Escalations.Critical.ComparisonOperator"`
	EscalationsCriticalPreCondition       string                                `position:"Query" name:"Escalations.Critical.PreCondition"`
	Dimensions                            string                                `position:"Query" name:"Dimensions"`
}

// PutGroupMetricRuleLabels is a repeated param struct in PutGroupMetricRuleRequest
type PutGroupMetricRuleLabels struct {
	Value string `name:"Value"`
	Key   string `name:"Key"`
}

// PutGroupMetricRuleCompositeExpression is a repeated param struct in PutGroupMetricRuleRequest
type PutGroupMetricRuleCompositeExpression struct {
	Times              string                                                     `name:"Times"`
	ExpressionList     *[]PutGroupMetricRuleCompositeExpressionExpressionListItem `name:"ExpressionList" type:"Repeated"`
	Level              string                                                     `name:"Level"`
	ExpressionRaw      string                                                     `name:"ExpressionRaw"`
	ExpressionListJoin string                                                     `name:"ExpressionListJoin"`
	N                  string                                                     `name:"N"`
}

// PutGroupMetricRuleCompositeExpressionExpressionListItem is a repeated param struct in PutGroupMetricRuleRequest
type PutGroupMetricRuleCompositeExpressionExpressionListItem struct {
	Period             string `name:"Period"`
	Threshold          string `name:"Threshold"`
	Id                 string `name:"Id"`
	MetricName         string `name:"MetricName"`
	ComparisonOperator string `name:"ComparisonOperator"`
	Statistics         string `name:"Statistics"`
}

// PutGroupMetricRuleResponse is the response struct for api PutGroupMetricRule
type PutGroupMetricRuleResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Result    Result `json:"Result" xml:"Result"`
}

// CreatePutGroupMetricRuleRequest creates a request to invoke PutGroupMetricRule API
func CreatePutGroupMetricRuleRequest() (request *PutGroupMetricRuleRequest) {
	request = &PutGroupMetricRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cms", "2019-01-01", "PutGroupMetricRule", "cms", "openAPI")
	request.Method = requests.POST
	return
}

// CreatePutGroupMetricRuleResponse creates a response to parse from PutGroupMetricRule response
func CreatePutGroupMetricRuleResponse() (response *PutGroupMetricRuleResponse) {
	response = &PutGroupMetricRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
