package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDBInstanceNetInfo invokes the rds.DescribeDBInstanceNetInfo API synchronously
func (client *Client) DescribeDBInstanceNetInfo(request *DescribeDBInstanceNetInfoRequest) (response *DescribeDBInstanceNetInfoResponse, err error) {
	response = CreateDescribeDBInstanceNetInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDBInstanceNetInfoWithChan invokes the rds.DescribeDBInstanceNetInfo API asynchronously
func (client *Client) DescribeDBInstanceNetInfoWithChan(request *DescribeDBInstanceNetInfoRequest) (<-chan *DescribeDBInstanceNetInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeDBInstanceNetInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDBInstanceNetInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDBInstanceNetInfoWithCallback invokes the rds.DescribeDBInstanceNetInfo API asynchronously
func (client *Client) DescribeDBInstanceNetInfoWithCallback(request *DescribeDBInstanceNetInfoRequest, callback func(response *DescribeDBInstanceNetInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDBInstanceNetInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeDBInstanceNetInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDBInstanceNetInfoRequest is the request struct for api DescribeDBInstanceNetInfo
type DescribeDBInstanceNetInfoRequest struct {
	*requests.RpcRequest
	ResourceOwnerId          requests.Integer `position:"Query" name:"ResourceOwnerId"`
	Flag                     requests.Integer `position:"Query" name:"Flag"`
	ClientToken              string           `position:"Query" name:"ClientToken"`
	GeneralGroupName         string           `position:"Query" name:"GeneralGroupName"`
	DBInstanceId             string           `position:"Query" name:"DBInstanceId"`
	ResourceOwnerAccount     string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount             string           `position:"Query" name:"OwnerAccount"`
	OwnerId                  requests.Integer `position:"Query" name:"OwnerId"`
	DBInstanceNetRWSplitType string           `position:"Query" name:"DBInstanceNetRWSplitType"`
}

// DescribeDBInstanceNetInfoResponse is the response struct for api DescribeDBInstanceNetInfo
type DescribeDBInstanceNetInfoResponse struct {
	*responses.BaseResponse
	SecurityIPMode      string                                        `json:"SecurityIPMode" xml:"SecurityIPMode"`
	RequestId           string                                        `json:"RequestId" xml:"RequestId"`
	InstanceNetworkType string                                        `json:"InstanceNetworkType" xml:"InstanceNetworkType"`
	DBInstanceNetInfos  DBInstanceNetInfosInDescribeDBInstanceNetInfo `json:"DBInstanceNetInfos" xml:"DBInstanceNetInfos"`
}

// CreateDescribeDBInstanceNetInfoRequest creates a request to invoke DescribeDBInstanceNetInfo API
func CreateDescribeDBInstanceNetInfoRequest() (request *DescribeDBInstanceNetInfoRequest) {
	request = &DescribeDBInstanceNetInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "DescribeDBInstanceNetInfo", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeDBInstanceNetInfoResponse creates a response to parse from DescribeDBInstanceNetInfo response
func CreateDescribeDBInstanceNetInfoResponse() (response *DescribeDBInstanceNetInfoResponse) {
	response = &DescribeDBInstanceNetInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
