package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeUpgradeMajorVersionTasks invokes the rds.DescribeUpgradeMajorVersionTasks API synchronously
func (client *Client) DescribeUpgradeMajorVersionTasks(request *DescribeUpgradeMajorVersionTasksRequest) (response *DescribeUpgradeMajorVersionTasksResponse, err error) {
	response = CreateDescribeUpgradeMajorVersionTasksResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeUpgradeMajorVersionTasksWithChan invokes the rds.DescribeUpgradeMajorVersionTasks API asynchronously
func (client *Client) DescribeUpgradeMajorVersionTasksWithChan(request *DescribeUpgradeMajorVersionTasksRequest) (<-chan *DescribeUpgradeMajorVersionTasksResponse, <-chan error) {
	responseChan := make(chan *DescribeUpgradeMajorVersionTasksResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeUpgradeMajorVersionTasks(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeUpgradeMajorVersionTasksWithCallback invokes the rds.DescribeUpgradeMajorVersionTasks API asynchronously
func (client *Client) DescribeUpgradeMajorVersionTasksWithCallback(request *DescribeUpgradeMajorVersionTasksRequest, callback func(response *DescribeUpgradeMajorVersionTasksResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeUpgradeMajorVersionTasksResponse
		var err error
		defer close(result)
		response, err = client.DescribeUpgradeMajorVersionTasks(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeUpgradeMajorVersionTasksRequest is the request struct for api DescribeUpgradeMajorVersionTasks
type DescribeUpgradeMajorVersionTasksRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageNumber           requests.Integer `position:"Query" name:"PageNumber"`
	PageSize             requests.Integer `position:"Query" name:"PageSize"`
	DBInstanceId         string           `position:"Query" name:"DBInstanceId"`
	TaskId               requests.Integer `position:"Query" name:"TaskId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	TargetMajorVersion   string           `position:"Query" name:"TargetMajorVersion"`
}

// DescribeUpgradeMajorVersionTasksResponse is the response struct for api DescribeUpgradeMajorVersionTasks
type DescribeUpgradeMajorVersionTasksResponse struct {
	*responses.BaseResponse
	RequestId        string                                    `json:"RequestId" xml:"RequestId"`
	PageNumber       int                                       `json:"PageNumber" xml:"PageNumber"`
	PageRecordCount  int                                       `json:"PageRecordCount" xml:"PageRecordCount"`
	TotalRecordCount int                                       `json:"TotalRecordCount" xml:"TotalRecordCount"`
	Items            []TasksInDescribeUpgradeMajorVersionTasks `json:"Items" xml:"Items"`
}

// CreateDescribeUpgradeMajorVersionTasksRequest creates a request to invoke DescribeUpgradeMajorVersionTasks API
func CreateDescribeUpgradeMajorVersionTasksRequest() (request *DescribeUpgradeMajorVersionTasksRequest) {
	request = &DescribeUpgradeMajorVersionTasksRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "DescribeUpgradeMajorVersionTasks", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeUpgradeMajorVersionTasksResponse creates a response to parse from DescribeUpgradeMajorVersionTasks response
func CreateDescribeUpgradeMajorVersionTasksResponse() (response *DescribeUpgradeMajorVersionTasksResponse) {
	response = &DescribeUpgradeMajorVersionTasksResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
