package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeBackendServers invokes the slb.DescribeBackendServers API synchronously
func (client *Client) DescribeBackendServers(request *DescribeBackendServersRequest) (response *DescribeBackendServersResponse, err error) {
	response = CreateDescribeBackendServersResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeBackendServersWithChan invokes the slb.DescribeBackendServers API asynchronously
func (client *Client) DescribeBackendServersWithChan(request *DescribeBackendServersRequest) (<-chan *DescribeBackendServersResponse, <-chan error) {
	responseChan := make(chan *DescribeBackendServersResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeBackendServers(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeBackendServersWithCallback invokes the slb.DescribeBackendServers API asynchronously
func (client *Client) DescribeBackendServersWithCallback(request *DescribeBackendServersRequest, callback func(response *DescribeBackendServersResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeBackendServersResponse
		var err error
		defer close(result)
		response, err = client.DescribeBackendServers(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeBackendServersRequest is the request struct for api DescribeBackendServers
type DescribeBackendServersRequest struct {
	*requests.RpcRequest
	AccessKeyId          string           `position:"Query" name:"access_key_id"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ListenerPort         requests.Integer `position:"Query" name:"ListenerPort"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Tags                 string           `position:"Query" name:"Tags"`
	LoadBalancerId       string           `position:"Query" name:"LoadBalancerId"`
}

// DescribeBackendServersResponse is the response struct for api DescribeBackendServers
type DescribeBackendServersResponse struct {
	*responses.BaseResponse
	RequestId string    `json:"RequestId" xml:"RequestId"`
	Listeners Listeners `json:"Listeners" xml:"Listeners"`
}

// CreateDescribeBackendServersRequest creates a request to invoke DescribeBackendServers API
func CreateDescribeBackendServersRequest() (request *DescribeBackendServersRequest) {
	request = &DescribeBackendServersRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2013-02-21", "DescribeBackendServers", "slb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeBackendServersResponse creates a response to parse from DescribeBackendServers response
func CreateDescribeBackendServersResponse() (response *DescribeBackendServersResponse) {
	response = &DescribeBackendServersResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
