package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeLoadBalancerAttribute invokes the slb.DescribeLoadBalancerAttribute API synchronously
func (client *Client) DescribeLoadBalancerAttribute(request *DescribeLoadBalancerAttributeRequest) (response *DescribeLoadBalancerAttributeResponse, err error) {
	response = CreateDescribeLoadBalancerAttributeResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeLoadBalancerAttributeWithChan invokes the slb.DescribeLoadBalancerAttribute API asynchronously
func (client *Client) DescribeLoadBalancerAttributeWithChan(request *DescribeLoadBalancerAttributeRequest) (<-chan *DescribeLoadBalancerAttributeResponse, <-chan error) {
	responseChan := make(chan *DescribeLoadBalancerAttributeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeLoadBalancerAttribute(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeLoadBalancerAttributeWithCallback invokes the slb.DescribeLoadBalancerAttribute API asynchronously
func (client *Client) DescribeLoadBalancerAttributeWithCallback(request *DescribeLoadBalancerAttributeRequest, callback func(response *DescribeLoadBalancerAttributeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeLoadBalancerAttributeResponse
		var err error
		defer close(result)
		response, err = client.DescribeLoadBalancerAttribute(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeLoadBalancerAttributeRequest is the request struct for api DescribeLoadBalancerAttribute
type DescribeLoadBalancerAttributeRequest struct {
	*requests.RpcRequest
	AccessKeyId          string           `position:"Query" name:"access_key_id"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Tags                 string           `position:"Query" name:"Tags"`
	LoadBalancerId       string           `position:"Query" name:"LoadBalancerId"`
}

// DescribeLoadBalancerAttributeResponse is the response struct for api DescribeLoadBalancerAttribute
type DescribeLoadBalancerAttributeResponse struct {
	*responses.BaseResponse
	VpcId                    string                                        `json:"VpcId" xml:"VpcId"`
	CreateTimeStamp          int64                                         `json:"CreateTimeStamp" xml:"CreateTimeStamp"`
	LoadBalancerSpec         string                                        `json:"LoadBalancerSpec" xml:"LoadBalancerSpec"`
	AutoReleaseTime          int64                                         `json:"AutoReleaseTime" xml:"AutoReleaseTime"`
	IsPublicAddress          string                                        `json:"IsPublicAddress" xml:"IsPublicAddress"`
	CreateTime               string                                        `json:"CreateTime" xml:"CreateTime"`
	LoadBalancerId           string                                        `json:"LoadBalancerId" xml:"LoadBalancerId"`
	PayType                  string                                        `json:"PayType" xml:"PayType"`
	AddressType              string                                        `json:"AddressType" xml:"AddressType"`
	NetworkType              string                                        `json:"NetworkType" xml:"NetworkType"`
	RegionId                 string                                        `json:"RegionId" xml:"RegionId"`
	EndTime                  string                                        `json:"EndTime" xml:"EndTime"`
	VSwitchId                string                                        `json:"VSwitchId" xml:"VSwitchId"`
	RequestId                string                                        `json:"RequestId" xml:"RequestId"`
	Bandwidth                int                                           `json:"Bandwidth" xml:"Bandwidth"`
	LoadBalancerStatus       string                                        `json:"LoadBalancerStatus" xml:"LoadBalancerStatus"`
	LoadBalancerName         string                                        `json:"LoadBalancerName" xml:"LoadBalancerName"`
	InternetChargeType       string                                        `json:"InternetChargeType" xml:"InternetChargeType"`
	Address                  string                                        `json:"Address" xml:"Address"`
	SlaveZoneId              string                                        `json:"SlaveZoneId" xml:"SlaveZoneId"`
	EndTimeStamp             int64                                         `json:"EndTimeStamp" xml:"EndTimeStamp"`
	RegionIdAlias            string                                        `json:"RegionIdAlias" xml:"RegionIdAlias"`
	MasterZoneId             string                                        `json:"MasterZoneId" xml:"MasterZoneId"`
	ListenerPorts            ListenerPorts                                 `json:"ListenerPorts" xml:"ListenerPorts"`
	ListenerPortsAndProtocal ListenerPortsAndProtocal                      `json:"ListenerPortsAndProtocal" xml:"ListenerPortsAndProtocal"`
	ListenerPortsAndProtocol ListenerPortsAndProtocol                      `json:"ListenerPortsAndProtocol" xml:"ListenerPortsAndProtocol"`
	BackendServers           BackendServersInDescribeLoadBalancerAttribute `json:"BackendServers" xml:"BackendServers"`
}

// CreateDescribeLoadBalancerAttributeRequest creates a request to invoke DescribeLoadBalancerAttribute API
func CreateDescribeLoadBalancerAttributeRequest() (request *DescribeLoadBalancerAttributeRequest) {
	request = &DescribeLoadBalancerAttributeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2013-02-21", "DescribeLoadBalancerAttribute", "slb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeLoadBalancerAttributeResponse creates a response to parse from DescribeLoadBalancerAttribute response
func CreateDescribeLoadBalancerAttributeResponse() (response *DescribeLoadBalancerAttributeResponse) {
	response = &DescribeLoadBalancerAttributeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
