package vpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyRouteTableAttributes invokes the vpc.ModifyRouteTableAttributes API synchronously
func (client *Client) ModifyRouteTableAttributes(request *ModifyRouteTableAttributesRequest) (response *ModifyRouteTableAttributesResponse, err error) {
	response = CreateModifyRouteTableAttributesResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyRouteTableAttributesWithChan invokes the vpc.ModifyRouteTableAttributes API asynchronously
func (client *Client) ModifyRouteTableAttributesWithChan(request *ModifyRouteTableAttributesRequest) (<-chan *ModifyRouteTableAttributesResponse, <-chan error) {
	responseChan := make(chan *ModifyRouteTableAttributesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyRouteTableAttributes(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyRouteTableAttributesWithCallback invokes the vpc.ModifyRouteTableAttributes API asynchronously
func (client *Client) ModifyRouteTableAttributesWithCallback(request *ModifyRouteTableAttributesRequest, callback func(response *ModifyRouteTableAttributesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyRouteTableAttributesResponse
		var err error
		defer close(result)
		response, err = client.ModifyRouteTableAttributes(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyRouteTableAttributesRequest is the request struct for api ModifyRouteTableAttributes
type ModifyRouteTableAttributesRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	Description          string           `position:"Query" name:"Description"`
	RouteTableName       string           `position:"Query" name:"RouteTableName"`
	ResourceUid          requests.Integer `position:"Query" name:"ResourceUid"`
	RouteTableId         string           `position:"Query" name:"RouteTableId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	Bandwidth            string           `position:"Query" name:"Bandwidth"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	KbpsBandwidth        string           `position:"Query" name:"KbpsBandwidth"`
	ResourceBid          string           `position:"Query" name:"ResourceBid"`
}

// ModifyRouteTableAttributesResponse is the response struct for api ModifyRouteTableAttributes
type ModifyRouteTableAttributesResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateModifyRouteTableAttributesRequest creates a request to invoke ModifyRouteTableAttributes API
func CreateModifyRouteTableAttributesRequest() (request *ModifyRouteTableAttributesRequest) {
	request = &ModifyRouteTableAttributesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Vpc", "2016-04-28", "ModifyRouteTableAttributes", "vpc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyRouteTableAttributesResponse creates a response to parse from ModifyRouteTableAttributes response
func CreateModifyRouteTableAttributesResponse() (response *ModifyRouteTableAttributesResponse) {
	response = &ModifyRouteTableAttributesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
