/*
Slurm Rest API RO

API to access Slurm. Only GET requests are implemented.

API version: 0.0.38
Contact: sales@schedmd.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package v0038

import (
	"encoding/json"
)

// checks if the V0038JobsResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &V0038JobsResponse{}

// V0038JobsResponse struct for V0038JobsResponse
type V0038JobsResponse struct {
	Meta *V0038Meta `json:"meta,omitempty"`
	// slurm errors
	Errors []V0038Error `json:"errors,omitempty"`
	// job descriptions
	Jobs []V0038JobResponseProperties `json:"jobs,omitempty"`
}

// NewV0038JobsResponse instantiates a new V0038JobsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewV0038JobsResponse() *V0038JobsResponse {
	this := V0038JobsResponse{}
	return &this
}

// NewV0038JobsResponseWithDefaults instantiates a new V0038JobsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewV0038JobsResponseWithDefaults() *V0038JobsResponse {
	this := V0038JobsResponse{}
	return &this
}

// GetMeta returns the Meta field value if set, zero value otherwise.
func (o *V0038JobsResponse) GetMeta() V0038Meta {
	if o == nil || IsNil(o.Meta) {
		var ret V0038Meta
		return ret
	}
	return *o.Meta
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *V0038JobsResponse) GetMetaOk() (*V0038Meta, bool) {
	if o == nil || IsNil(o.Meta) {
		return nil, false
	}
	return o.Meta, true
}

// HasMeta returns a boolean if a field has been set.
func (o *V0038JobsResponse) HasMeta() bool {
	if o != nil && !IsNil(o.Meta) {
		return true
	}

	return false
}

// SetMeta gets a reference to the given V0038Meta and assigns it to the Meta field.
func (o *V0038JobsResponse) SetMeta(v V0038Meta) {
	o.Meta = &v
}

// GetErrors returns the Errors field value if set, zero value otherwise.
func (o *V0038JobsResponse) GetErrors() []V0038Error {
	if o == nil || IsNil(o.Errors) {
		var ret []V0038Error
		return ret
	}
	return o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *V0038JobsResponse) GetErrorsOk() ([]V0038Error, bool) {
	if o == nil || IsNil(o.Errors) {
		return nil, false
	}
	return o.Errors, true
}

// HasErrors returns a boolean if a field has been set.
func (o *V0038JobsResponse) HasErrors() bool {
	if o != nil && !IsNil(o.Errors) {
		return true
	}

	return false
}

// SetErrors gets a reference to the given []V0038Error and assigns it to the Errors field.
func (o *V0038JobsResponse) SetErrors(v []V0038Error) {
	o.Errors = v
}

// GetJobs returns the Jobs field value if set, zero value otherwise.
func (o *V0038JobsResponse) GetJobs() []V0038JobResponseProperties {
	if o == nil || IsNil(o.Jobs) {
		var ret []V0038JobResponseProperties
		return ret
	}
	return o.Jobs
}

// GetJobsOk returns a tuple with the Jobs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *V0038JobsResponse) GetJobsOk() ([]V0038JobResponseProperties, bool) {
	if o == nil || IsNil(o.Jobs) {
		return nil, false
	}
	return o.Jobs, true
}

// HasJobs returns a boolean if a field has been set.
func (o *V0038JobsResponse) HasJobs() bool {
	if o != nil && !IsNil(o.Jobs) {
		return true
	}

	return false
}

// SetJobs gets a reference to the given []V0038JobResponseProperties and assigns it to the Jobs field.
func (o *V0038JobsResponse) SetJobs(v []V0038JobResponseProperties) {
	o.Jobs = v
}

func (o V0038JobsResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o V0038JobsResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Meta) {
		toSerialize["meta"] = o.Meta
	}
	if !IsNil(o.Errors) {
		toSerialize["errors"] = o.Errors
	}
	if !IsNil(o.Jobs) {
		toSerialize["jobs"] = o.Jobs
	}
	return toSerialize, nil
}

type NullableV0038JobsResponse struct {
	value *V0038JobsResponse
	isSet bool
}

func (v NullableV0038JobsResponse) Get() *V0038JobsResponse {
	return v.value
}

func (v *NullableV0038JobsResponse) Set(val *V0038JobsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableV0038JobsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableV0038JobsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableV0038JobsResponse(val *V0038JobsResponse) *NullableV0038JobsResponse {
	return &NullableV0038JobsResponse{value: val, isSet: true}
}

func (v NullableV0038JobsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableV0038JobsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


